/*
 * osd.h
 *
 * Copyright (C) 2008 Christophe Thommeret <hftom@free.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef OSD_H
#define OSD_H

#include "filebrowser.h"
#include "osdmenu.h"
#include "osdcontrolbar.h"



class VideoWidget;



class Osd : public QObject
{
	Q_OBJECT
public:
	Osd( VideoWidget *parent, GLFunc *glf );
	void mouseMove( QMouseEvent *e );
	bool mouseClicked( QMouseEvent *e );
	void mouseReleased( QMouseEvent *e );
	void wheelEvent( QWheelEvent *e );
	void paint();
	void resize( int w, int h );

private slots:
	void shot();

private:
	FileBrowser *browser;
	OsdMenu *menu;
	OsdControlBar *control;
	OsdConfig *osdConfig;
	VideoWidget *vw;
};

#endif // OSD_H
